<link rel="import" href="../polymer/polymer-element.html">
<link rel="import" href="../paper-card/paper-card.html">
<link rel="import" href="../paper-button/paper-button.html">
<link rel="import" href="../iron-icon/iron-icon.html">
<link rel="import" href="../paper-icon-button/paper-icon-button.html">
<link rel="import" href="../iron-icons/iron-icons.html">

<dom-module id="fotosocial-post">
  <template>
    <style>
      :host {
        display: block;
      }
      .card-image {

      }
    </style>
    <paper-card>
      <div class="card-content">
        <div class="card-image">
          <img src="[[post.photo]]" />
        </div>
      </div>
      <div class="card-actions">
        <p>[[post.description]]</p>
        <div class="horizontal justified">
          <paper-icon-button icon="thumb-up" on-click="_postLike"></paper-icon-button>[[likes]]
          <paper-icon-button icon="thumb-down" on-click="_postUnlike"></paper-icon-button>[[unlikes]]
        </div>
      </div>
    </paper-card>
  </template>

  <script>
    /**
     * `fotosocial-post`
     * card del post de fotosocial
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class FotosocialPost extends Polymer.Element {
      static get is() { return 'fotosocial-post'; }
      static get properties() {
        return {
          post: {
            type: Object,
            value: {}
          },
          likes: {
            type: Number,
            value: 0,
            computed: '_getLikes(post)'
          },
          unlikes: {
            type: Number,
            value: 0,
            computed: '_getUnlikes(post)'
          }
        };
      }

      connectedCallback() {
        super.connectedCallback();

      }

      _getLikes(post) {
        return post.likes !== 0 ? post.likes.length : 0;
      }

      _getUnlikes(post) {
        return post.unlikes !== 0 ? post.unlikes.length : 0;
      }

      _postLike() {
        this._eventLike('like');
      }

      _postUnlike() {
        this._eventLike('unlike');
      }

      _eventLike(e) {
        this.dispatchEvent(new CustomEvent('post-like-unlike', {
          bubbles: true,
          composed: true,
          detail: {
            postId: this.post.id,
            likeUnlike: e
          }
        }));
      }
    }

    window.customElements.define(FotosocialPost.is, FotosocialPost);
  </script>
</dom-module>
